//*************************************************************************
//  d͌vP̃\tg
//*************************************************************************

#include <msp430x20x3.h>

#define RED  0x80
#define GR   0x40

float sum;                              // d͌vZp
int ad_dat[20];                         // ADf[^ۑp
int idx;                                // ADTvÕCfbNX
int f_iv;                               // 胂[h V or I
char f_tgl;                             // LED_ŗp
int tmp;                                // ꎞIϐ
float pow;                              // 肵d͒l
unsigned char LED;                      // LEDpϐ

void main(void)
{
  WDTCTL = WDTPW + WDTHOLD;             // Stop watchdog timer

  BCSCTL1 = CALBC1_1MHZ;                // Set DCO to 1MHz
  DCOCTL = CALDCO_1MHZ;
  BCSCTL3 = LFXT1S_2;                   // ACLK = VLOCLK

  SD16CTL = SD16VMIDON + SD16REFON + SD16SSEL_1;  // VMID ON, 1.2V ref on, SMCLK
  SD16INCTL0 = SD16INCH_4;              // Diff inputs A4- & A4+ = ACV
  SD16CCTL0 = SD16IE + SD16DF + SD16OSR_1024; // , oC|[, OSR=1024
  SD16CTL &= ~SD16VMIDON;               // VMID off: used to settle ref cap
  SD16AE = SD16AE0 + SD16AE1 + SD16AE2; // SD16AE A0 - A2O͒[q

  P1IE |= 0x10;                         // P1.4 AC Trigger
  P1IES |= 0x10;                        // P1.4 Hi/lo edge
  P1IFG &= ~0x10;                       // P1.4 IFG cleared
  P1SEL |= 0x8;                         // P1.3 = Vref
  P1DIR |= 0xc0;                        // P1.6, 7 for Output, GR RED LED
  P2SEL = 0;                            // P2.6, 7 GPIO
  P2DIR |= 0xc0;                        // P2.6, 7 for Output, P2.6 = BZ

  TACCTL0 = CCIE;                       // TACCR0 interrupt enabled
  TACCR0 = 3600;                        // 0.2s
  TACTL = TASSEL_1 + MC_1;              // ACLK, upmode

  _BIS_SR(GIE);                         // ݉

  while(1)
  {
    if (pow < 20) LED = 0;              // 20W LED
    else if (pow < 100)                 // 20Wȏ 100W GR 2s_
    {
      LED = GR;
      TACCR0 = 12000;
    }
    else if (pow < 200)                 // 100Wȏ 200W GR 0.6s_
    {
      LED = GR;
      TACCR0 = 3600;
    }
    else if (pow < 300)                 // 200Wȏ 300W GR 0.2s_
    {
      LED = GR;
      TACCR0 = 1200;
    }
    else if (pow < 400)                 // 300Wȏ 400W ORANGE 2s_
    {
      LED = GR + RED;
      TACCR0 = 12000;
    }
    else if (pow < 500)                 // 400Wȏ 500W ORANGE 0.6s_
    {
      LED = GR + RED;
      TACCR0 = 3600;
    }
    else if (pow < 700)                 // 500Wȏ 700W ORANGE 0.2s_
    {
      LED = GR + RED;
      TACCR0 = 1200;
    }
    else if (pow < 900)                 // 700Wȏ 900W RED 2s_
    {
      LED = RED;
      TACCR0 = 12000;
    }
    else if (pow < 1100)                // 900Wȏ 1100W RED 0.6s_
    {
      LED = RED;
      TACCR0 = 3600;
    }
    else if (pow < 1300)                // 1100Wȏ 1300W GR 0.2s_
    {
      LED = RED;
      TACCR0 = 1200;
    }
    else                                // 1300Wȏ RED _
    {
      LED = RED;
      TACCR0 = 12;
      P2OUT |= 0x40;                    // BZ ON
    }
  }
}

#pragma vector=SD16_VECTOR
__interrupt void SD16ISR(void)
{
  if (f_iv == 0)
  {
    ad_dat[idx++] = SD16MEM0;           // ad_datϐADϊl
    if (idx >= 20)                      // idx20ȏȂACVTvOI
    {
      SD16CCTL0 &= ~SD16SC;             // ADϊ~
      SD16INCTL0 = SD16INCH_0;          // Diff inputs A0- & A0+@ACI
      idx = 0;                          // idxNA
      f_iv = 1;                         // 胂[hACI
      sum = 0;                          // sumNA
    }
  }
  else
  {
    tmp = SD16MEM0;                     // ACI̎擾
    sum += (float)ad_dat[idx++] * tmp;  // d͒l̐ώZ
    if (idx >= 20)                      // idx20ȏȂACITvOI
    {
      SD16CCTL0 &= ~SD16SC;                 // ADϊ~
      SD16INCTL0 = SD16INCH_4;          // Diff inputs A4- & A4+ ACV
      idx = 0;                          // idxNA
      f_iv = 0;                         // 胂[hACV
      pow = sum / 3.3e6;                // d͒ľvZivZj
      P2OUT &= ~0x40;                   // BZ OFF
    }
  }
}



// Port 1 interrupt service routine
#pragma vector=PORT1_VECTOR
__interrupt void Port_1(void)           // ACṼgK
{
  if (idx == 0)                         // ADTvOłȂ
  {
    SD16CCTL0 |= SD16SC;                // ADϊJn
  }
  P1IFG &= ~0x10;                       // P1.4 IFG cleared
}

// Timer A0 interrupt service routine
#pragma vector=TIMERA0_VECTOR
__interrupt void Timer_A (void)
{
  f_tgl ^= 1;                           // A_Ԃ𔽓]
  if (f_tgl == 0)                       // f_tgl = 0LED, f_tgl = 1LED_
  {
    P1OUT &= ~0xc0;                     // RED GR OFF

  }
  else
  {
    P1OUT |= LED;                       // LED ON, FGRAREDŎw
  }
}